package server;

/**
 * <p>Title: Ʈp Ʈ ϴ ּҴ</p>
 * <p>Description: ó - Unit</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

/*
      - 䱸 -

   : ִ 밡 ο = 1000 (=99*9) 
  äù : ִ 밡 ο = 9 
*/
import java.io.*;
import network.*;
import transmission.*;
import transmission.exception.*;
import transmission.io.*;


public class UnitSender implements ProtocolInterface
{
  private ReadStream m_reader = null;  //б Ʈ
  private WriteStream m_writer = null; // Ʈ
  private Unit m_unit = null; //Ʈp Ʈ д Ŭ
  private ServerInterface m_serverService = null; //  ̽ (See: Server.java)
  private UserInterface m_rooms = null;

  //not use
  private UnitSender() {}

  /**
   * UnitSender ϰ
   * Ϳ Unit ´
   *
   * @param unit  Unit
   * @param available  ùƮ (ֹ  )
   * */
  public UnitSender(Unit unit, byte available)
  {
    m_unit = unit;
    m_serverService = m_unit.getServerInterface();
    m_rooms = m_unit.getRooms();
    m_reader = new ReadStream(getInputStream());
    m_writer = new WriteStream(getOutputStream());
  }

  /**
   * Ʈ Ŭ̾Ʈ 
   *
   * @return boolean ۰
   * */
  public boolean send()
  {
    try
    {
      if (isAlive())
      {
        m_reader = new ReadStream(getInputStream());
        m_writer = new WriteStream(getOutputStream());

        byte minor = m_reader.readByte();
        if (minor != (byte)0) throw new IllegalMinorVersionException("MinorVer="+minor);

        byte service = m_reader.readByte();

        switch(service)
        {
          //α
          case LOGIN :
            login();
            break;
          //äù Ʈ 䱸
          case GET_CHATROOM_LIST :
            get_chatroom_list();
            break;
          //ǿ ִ  Ʈ 䱸
          case GET_STANDBY_USER_LIST :
            get_standby_user_list();
            break;
          //äù 
          case MAKE_CHATROOM :
            make_chatroom();
            break;
          //äù α
          case CHAT_LOGIN :
            chat_login();
            break;
          //Ư äù  Ʈ 䱸
          case GET_CHATROOM_USER_LIST :
            get_chatroom_user_list();
            break;
          //޼ 
          case SEND_MESSAGE :
            message();
            break;
          //äù   
          case DESTROY_CHATROOM :
            destroy_chatroom();
            break;
          //Ư äù(Ϲäù|)  
          case EXIT_ROOM_USER :
            exit_room_user();
            break;
          //ʴϱ
          case INVITE :
            invite();
            break;
          case REJECT_INVITE_MESSAGE :
            reject_invite_message();
            break;
          //äù濡 α׾ƿϱ
          case CHAT_LOGOUT :
            chat_logout();
            break;
          //߸ 񽺰 ص б 񽺸  ʴ´
          default :
            System.out.println("Unknown Message !");
            return false;
        }

        //Ŭ̾Ʈ û ؼ б غѴ
        //(See: Server.java processReadRequest Լ)
        m_unit.getNetworkInterface().receiveFrame(getUnit());
        return true;
      }
    }
    catch(Exception e)
    {
      System.out.println("UnitSender.UnitSender.e="+e.toString());
      e.printStackTrace();
    }

    stopService(); //Ʈ  ݰ Unit 񽺸 Ѵ (See: Unit.java)

    return true;
  }

  //////////////////////////////////////////////////////////////////////////////

  /**
   * (äô) α
   *
   * (sinario) ó ѹ ̷
   *
   * (->) major, minor, service(LOGIN), string(id)
   * (<-) major, minor, service(LOGIN), byte(result[0|1]), byte(roomNo), byte(userNo)
   *
   *    [result]
   *        0x00, 0x10: α 
   *        0x01: α 
   * */
  private final void login() throws IOException
  {
    //б
    String id = m_reader.readString();

    // ̵ ִ ǰ äù ˻
    Object[] rooms = m_rooms.getClientList();
    boolean isAleadyExist = false; //̹  ̵ α ִ ˻ϴ ÷
    for (int i=0; i<rooms.length; i++)
    {
      ChatRoom room = (ChatRoom)rooms[i];
      Object users[] = room.getUsrList();
      for (int j=0; j<users.length; j++)
      {
        ChatUser user = (ChatUser)users[j];
        if (user.getId().equalsIgnoreCase(id))
        {
          isAleadyExist = true;
          break;
        }
        if (isAleadyExist) break;
      }
    }

    int userNo = -1;
    if (isAleadyExist == false)
    {
      //ǿ ä 
      userNo = addToStandbyRoom(id);
    }
    else
    {
      //̹ ϴ  ̵
      userNo = -2;
      //System.out.println("̹ ϴ !");
    }

    //ϰ 
    ByteArrayOutputStream baos = new ByteArrayOutputStream();
    WriteStream w = new WriteStream(baos);

    if (userNo == -1) //α  ( Ǵ  ִο ʰ)
      w.writeByte(0x00);
    else if (userNo == -2) //α  (̵ ߺ)
      w.writeByte(0x10);
    else  //α 
      w.writeByte(0x01);

    w.writeByte(STANDBY_ROOM);
    w.writeByte((byte)userNo);

    //ϰ 
    byte[] retBody = baos.toByteArray();
    baos.close(); baos = null;
    w.close(); w = null;

    //
    sendFrame(LOGIN, retBody);
  }

  /**
   *  ǿ ä ߰ϱ
   *
   * (caution)  ̹ Ǿ ־Ѵ
   * (!) login() Լ ȣ
   *
   * @return int ǳ ϵ ȣ
   * */
  private final int addToStandbyRoom(String id)
  {
    ChatRoom standby = (ChatRoom)m_rooms.getClient(new Integer(STANDBY_ROOM));
    int serial = standby.addClient(id, m_unit);

    if (serial == -1) //ִ Ŭ̾Ʈ  ʰ, ǿ ä Ͻ
    {
      System.out.println("[] ִ   ʰ!");
      stopService(); // 
    }
    else //ǿ ä ϼ
    {
      m_unit.setId(id);
      m_unit.setSerialNum(serial);
      m_unit.setRoomNo(STANDBY_ROOM);
    }

    return serial;
  }

  /**
   *  äù Ʈ 䱸
   *
   *  (->) major, minor, service(GET_CHATROOM_LIST)
   *  (<-) major, minor, service(GET_CHATROOM_LIST), byte(氹), byte(ȣ), String()
   * */
  public final void get_chatroom_list() throws IOException
  {
    //äù 
    Object obj[] = m_rooms.getClientList();

    //ϰ 
    ByteArrayOutputStream baos = new ByteArrayOutputStream();
    WriteStream w = new WriteStream(baos);

    w.writeByte((byte)(obj.length - 1));//氹,   

    for (int i=0; i<obj.length; i++)
    {
      ChatRoom info = (ChatRoom)obj[i];

      byte roomNo = info.getNo(); //ȣ
      String roomTitle = info.getTitle(); //

      byte maxUser = info.getMaxUser(); //ִο
      String passwd = info.getPasswd(); //ȣ

      if (roomNo != STANDBY_ROOM) //  ش
      {
        w.writeByte(roomNo);
        w.writeString(roomTitle);
        w.writeByte(maxUser);
        w.writeString(passwd);
      }
    }

    //
    byte[] ret = baos.toByteArray();
    baos.close(); baos = null;
    w.close(); w = null;
    sendFrame(GET_CHATROOM_LIST, ret);
  }

  /**
   *  äù 
   *
   * (<-) major, minor, service(MAKE_CHATROOM), byte(ο), String(), byte(/), String(ȣ[ ϰ])
   * (->) major, minor, service(MAKE_CHATROOM), (| [0|1])
   * */
  private final void make_chatroom() throws IOException
  {
    //б
    byte max = m_reader.readByte(); //äù 밡 ο
    String title = m_reader.readString(); //äù 
    byte security = m_reader.readByte(); //(SECURITY_ROOM),(OPEN_ROOM)
    String passwd = m_reader.readString(); //й/  ȣ д´

    //äù  ߺ ˻
    Object[] rooms = this.m_rooms.getClientList();
    boolean isAlreadyExist = false; //äù  ̹ ϴ ˻ϴ ÷
    for (int i=0; i<rooms.length; i++)
    {
      ChatRoom room = (ChatRoom)rooms[i];
      if (room.getTitle().equalsIgnoreCase(title.trim()))
      {
        isAlreadyExist = true;
        break;
      }
    }

    //ϰ 
    byte[] retAry = new byte[1];

    if (isAlreadyExist == false)
    {
      // 
      int serial = m_rooms.getUniqueId(); // ϴ ȣ
      boolean ret = m_rooms.addClient(new Integer(serial), new ChatRoom(title, (byte)serial, MAX_ROOM_USER, passwd));

      //ϰ 
      if (ret == false) //ִ  氹 ʰ
        retAry[0] = 0x00;
      else
        retAry[0] = 0x01; //
    }
    else
      retAry[0] = 0x10; //äù  ߺ 

    // 
    sendFrame(MAKE_CHATROOM, retAry);

    //  äù   ˸
    broadcastNewRoomInfo();
  }

  /**
   *   äù   ˸
   * */
  private final void broadcastNewRoomInfo() throws IOException
  {
    //äù 
    Object obj[] = m_rooms.getClientList();

    //ϰ 
    ByteArrayOutputStream baos = new ByteArrayOutputStream();
    WriteStream w = new WriteStream(baos);

    w.writeByte((byte)(obj.length - 1));//氹,   

    for (int i=0; i<obj.length; i++)
    {
      ChatRoom info = (ChatRoom)obj[i];

      byte roomNo = info.getNo(); //ȣ
      String roomTitle = info.getTitle(); //

      byte maxUser = info.getMaxUser(); //ִο
      String passwd = info.getPasswd(); //ȣ

      if (roomNo != STANDBY_ROOM) //  ش
      {
        w.writeByte(roomNo);
        w.writeString(roomTitle);
        w.writeByte(maxUser);
        w.writeString(passwd);
      }
    }

    //
    byte[] ret = baos.toByteArray();
    baos.close(); baos = null;
    w.close(); w = null;

    Object roomList[] = this.m_rooms.getClientList();
    for (int i=0; i<roomList.length; i++)
    {
      ChatRoom room = (ChatRoom)roomList[i];
      Object userList[] = room.getUsrList();

      for (int j=0; j<userList.length; j++)
      {
        ChatUser user = (ChatUser)userList[j];
        OutputStream os = user.getUnit().getOutputStream();
        get_chatroom_list(ret, os);
      }
    }

  }

  /**
   *  äù Ʈ 
   *
   *  (<-) major, minor, service(GET_CHATROOM_LIST), byte(氹), byte(ȣ), String()
   * */
  private final void get_chatroom_list(byte[] body, OutputStream os) throws IOException
  {
    WriteStream writer = new WriteStream(os);
    writer.writeByte(MAJOR_VER);
    writer.writeByte(MINOR_VER);
    writer.writeByte(GET_CHATROOM_LIST);
    writer.write(body, 0, body.length);
    writer.flush();
  }

  /**
   * äù濡 α
   *
   * (sinario) äù濡 α,  α׾ƿ  ڵ óȴ
   *
   * (<-) major, minor, service(CHAT_LOGIN), String(̵), byte(Խ ȣ), byte( ȣ)
   * (->) major, minor, service(CHAT_LOGIN), byte(|[0|1]), byte(äù ȣ), byte(äù ȣ)
   * */
  private final void chat_login() throws IOException
  {
    //б
    String usrId = m_reader.readString(); //ä ̵
    byte roomNo = m_reader.readByte(); //ȣ
    byte preRoomNo = m_reader.readByte(); // ȣ

    //ä 濡
    ByteArrayOutputStream baos = new ByteArrayOutputStream();
    WriteStream w = new WriteStream(baos);

    ChatRoom room = (ChatRoom)m_rooms.getClient(new Integer(roomNo));
    int usrNo = room.addClient(usrId, m_unit); //  ´
    // 
    if (usrNo <= -1) //ִ ο ʰ
      w.writeByte(0x00);
    else // , usrNo 濡 еǴ ȣ
      w.writeByte(0x00);

    //äù濡  ԽǷ, ǿ ִ  
    if (usrNo > -1)
    {
      ChatRoom standbyRoom = (ChatRoom)m_rooms.getClient(new Integer(STANDBY_ROOM));
      boolean ret = standbyRoom.removeClient(preRoomNo);
    }

    //ǿ äù ŰǷ  
    m_unit.setId(usrId);
    m_unit.setSerialNum(usrNo);
    m_unit.setRoomNo(roomNo);

    //äù ȣ 
    w.writeByte(usrNo);
    //ο äù ȣ
    w.writeByte(roomNo);

    //
    sendFrame(CHAT_LOGIN, baos.toByteArray());
    baos.close(); baos = null;
    w.close(); w = null;

    //äù濡  ο ˸
    alarm_to_user(ALARM_CHATUSER_LOGIN, roomNo, Byte.parseByte(String.valueOf(usrNo)), usrId);
  }

  /**
   * Ư äù[|]  Ʈ 
   *
   * @return byte[]   +  ̵ +  ȣ
   * */
  private final byte[] getUsrList(byte roomNo) throws IOException
  {
    ChatRoom room = (ChatRoom)m_rooms.getClient(new Integer(roomNo));
    Object[] usrlist = room.getUsrList();

    ByteArrayOutputStream baos = new ByteArrayOutputStream();
    WriteStream w = new WriteStream(baos);

    w.writeByte(usrlist.length); // 

    for (int i=0; i<usrlist.length; i++)
    {
      ChatUser usrInfo = (ChatUser)usrlist[i];
      String id = usrInfo.getId(); //̵
      String no = String.valueOf(usrInfo.getSerial()); //ȣ
      w.writeString(id);
      w.writeString(no);
    }

    byte[] retBody = baos.toByteArray();
    baos.close(); baos =  null;
    w.close(); w = null;

    return retBody;
  }

  /**
   *    Ʈ 䱸
   *  (<-) major, minor, service(GET_STANDBY_USER_LIST)
   *  (->) major, minor, service(GET_STANDBY_USER_LIST), byte(Ѱ), String(id), byte(no)
   * */
  private final void get_standby_user_list() throws IOException
  {
    //ϰ 
    byte[] retBody = getUsrList(STANDBY_ROOM);

    //
    sendFrame(GET_STANDBY_USER_LIST, retBody);
  }

  /**
   *  Ư äù  Ʈ 䱸
   *
   * (<-) major, minor, service(GET_CHATROOM_USER_LIST), byte(ȣ)
   * (->) major, minor, service(GET_CHATROOM_USER_LIST), byte(ȣ)
   * */
  private final void get_chatroom_user_list() throws IOException
  {
    //б
    byte roomNo = m_reader.readByte();

    //ϰ 
    byte[] retBody = getUsrList(roomNo);

    //
    sendFrame(GET_CHATROOM_USER_LIST, retBody);
  }

  /**
   * ޼ 
   *
   * (<-) major, minor, service(SEND_MESSAGE), byte(ȣ), byte(ȣ), String(̵), String(޼)
   * (->) major, minor, service(SEND_MESSAGE), byte(ȣ), byte(ȣ), String(̵), String(޼)
   * */
  private final void message() throws IOException
  {
    //б
    byte chatroomNo = m_reader.readByte(); //äù ȣ
    byte usrNo = m_reader.readByte();      // ȣ
    String usrId = m_reader.readString();  // ̵
    String usrMsg = m_reader.readString(); // ޼
    //
    broadcast(chatroomNo, usrNo, usrId, usrMsg); //Ư äù濡 Ѹ
  }

  /**
   * Ư äù濡 ä ޼ Ѹ
   *
   * (->) major, minor, service(SEND_MESSAGE), byte(ȣ), byte(ȣ), String(̵), String(޼)
   * */
  private final void broadcast(byte chatroomNo, byte usrNo, String usrId, String usrMsg)
    throws IOException
  {
    ChatRoom room = (ChatRoom)m_rooms.getClient(new Integer(chatroomNo));
    Object usrlist[] = room.getUsrList();

    for (int i=0; i<usrlist.length; i++)
    {
      ChatUser usrInfo = (ChatUser)usrlist[i];
      OutputStream os = usrInfo.getUnit().getOutputStream();
      WriteStream w = new WriteStream(os);

      w.writeByte(MAJOR_VER); //ֹ
      w.writeByte(MINOR_VER); //ι
      w.writeByte(SEND_MESSAGE); //񽺹ȣ
      w.writeByte(chatroomNo); //ȣ
      w.writeByte(usrNo); //ȣ
      w.writeString(usrId); //̵
      w.writeString(usrMsg); //޼
      w.flush();
    }
  }

  /**
   * Ư äù()  
   *
   * (sinario) ȣ ǹȣ ƴ϶, ó ڵ Ƿ  ű
   *
   * (<-) major, minor, service(EXIT_ROOM_USER), byte(ȣ), byte(ȣ), String(̵)
   * (->) major, minor, service(EXIT_ROOM_USER), byte(ȣ), byte(ȣ)
   * */
  private final void exit_room_user() throws IOException
  {
    //
    ChatRoom room = (ChatRoom)m_rooms.getClient(new Integer(STANDBY_ROOM));
    //濡  
    boolean ret = room.removeClient(m_unit.getSerialNum());
    //For Debugging
    //System.out.println("exit_room_user  ="+room+"  ȣ="+m_unit.getSerialNum()+" ="+ret);
    //ϰ 
    byte[] retBody = new byte[0];

    //
    sendFrame(EXIT_ROOM_USER, retBody);
    stopService();
  }

  /**
   * äô  Ư äù ʴ
   * (<-) major, minor, service(INVITE), byte(ʴǷڹȣ), String(ʴھ̵), byte(ʴȣ), byte(ʴҾ̵), byte(ʴȣ)
   * (->) major, minor, service(INVITE), byte([0x00|0x01])
   *
   * @return byte ʴû  [0x00 | 0x01 ]
   * */
  private final void invite() throws IOException
  {
    //б
    byte roomNo = m_reader.readByte(); //ʴϷ  ִ ȣ
    //byte userNo = m_reader.readByte(); //ʴϷ ȣ
    String userId = m_reader.readString(); //ʴϷ  ̵

    byte inviteUserRoomNo = m_reader.readByte(); //ʴϷ  ִ ȣ
    String inviteUserId = m_reader.readString(); //ʴϷ  ̵
    byte inviteUserNo = m_reader.readByte(); //ʴϷ  ȣ

    // 
    byte[] retBody = new byte[1];
    retBody[0] = 0x01;

    //
    sendFrame(INVITE, retBody);

    System.out.println( userId+" "+inviteUserId +" ȣ "+ inviteUserRoomNo+" ȣϿϴ.");

    // ʴ޼ 
    sendInviteMsg(roomNo, userId, inviteUserRoomNo, inviteUserNo);
  }

  /**
   * ûڿ û ޼  ˸
   *
   * (<-) major, minor, service(REJECT_INVITE_MESSAGE), byte(û ȣ), byte(û ̵), String(̵)
   * (->) None
   * */
  private final void reject_invite_message() throws IOException
  {
    //б
    byte roomNo = m_reader.readByte(); //ʴ븦  ȣ
    //byte userNo = m_reader.readByte(); //ʴ븦  ȣ
    String userId = m_reader.readString(); //ʴ ̵
    //̵ Byte Stream
    ByteArrayOutputStream baos = new ByteArrayOutputStream();
    WriteStream ws = new WriteStream(baos);
    ws.writeString(userId.trim());
    byte[] body = baos.toByteArray();
    ws.close(); baos.close();
    ws = null; baos = null;
    //
    ChatRoom room = (ChatRoom)m_rooms.getClient(new Integer(roomNo));
    Object[] list = room.getUsrList();
    for (int i=0; i<list.length; i++)
    {
      ChatUser user = (ChatUser)list[i];
      OutputStream os = user.getUnit().getOutputStream();
      sendFrame(REJECT_INVITE_MESSAGE, body, os);
    }
  }

  /**
   * Ư濡 ִ  ʴ޼ 
   * */
  private final boolean sendInviteMsg(byte roomNo, String userId, byte inviteRoomNo, byte inviteUserNo)
      throws IOException
  {
    //ä÷뿡 ä ŸƲ
    ChatRoom room = (ChatRoom)m_rooms.getClient(new Integer(roomNo));
    String title = room.getTitle();
    //ʴϷ  ʴ޼ 
    ChatRoom sbRoom = (ChatRoom)m_rooms.getClient(new Integer(inviteRoomNo)); // ( ǿ äʴ밡 ̷)
    ChatUser user = (ChatUser)sbRoom.getUser((int)inviteUserNo);
    OutputStream os = user.getUnit().getOutputStream();

    // ޼ٵ ۼ
    ByteArrayOutputStream baos = new ByteArrayOutputStream();
    WriteStream w = new WriteStream(baos);
    w.writeByte(roomNo);//ʴ ȣ
    w.writeString(userId);//ʴ ̵
    w.writeString(title);//äù ŸƲ
    w.writeByte(inviteRoomNo);//ʴ   ȣ
    w.writeByte(inviteUserNo);//ʴ   ȣ
    //
    sendFrame(INVITE_MESSAGE, baos.toByteArray(), os);
    baos.close(); baos = null;
    w.close(); w = null;

    return true;
  }

  /**
   * äù濡 α׾ƿ  Ƿ 
   *
   * (<-) major, minor, service(CHAT_LOGOUT), byte(ȣ), byte(ȣ), String(̵)
   * (->) major, minor, service(CHAT_LOGOUT), byte([0|1]), byte( ȣ)
   * */
  private final void chat_logout() throws IOException
  {
    //б
    byte roomNo = m_reader.readByte(); //ȣ
    byte userNo = m_reader.readByte(); //ȣ
    String userId = m_reader.readString(); //̵
    //äù濡  
    ChatRoom room = (ChatRoom)m_rooms.getClient(new Integer(roomNo));
    boolean ret = room.removeClient((int)userNo);
    //äù濡 α׾ƿ Ͼ äù ˻,
    //äڰ 0̸  Ѵ
    if (room.getUsrList().length <= 0)
    {
        boolean r = m_rooms.removeClient(new Integer(roomNo));
        //For Debugging
        System.out.println("ȣ "+roomNo+"  ="+r);
    }

    //   鿡 äù Ʈ Ѵ
    broadcastNewRoomInfo();

    //For Debugging
    Object[] dbg = m_rooms.getClientList();
    for (int i=0; i<dbg.length; i++)
    {
      ChatRoom r = (ChatRoom)dbg[i];
      System.out.println("   ="+r.getTitle()+", "+r.getNo());
    }

    //For Debugging
    System.out.println("chat_logout(). ="+roomNo+" ="+userNo+"  userId="+userId+" ="+ret);

    // , Ƿ  ű
    room = (ChatRoom)m_rooms.getClient(new Integer(STANDBY_ROOM));
    int newUserNo = room.addClient(userId, m_unit);
    this.m_unit.setRoomNo(STANDBY_ROOM);
    this.m_unit.setSerialNum(newUserNo);

    //ϰ 
    ByteArrayOutputStream baos = new ByteArrayOutputStream();
    WriteStream w = new WriteStream(baos);
    w.writeByte(0x01);//äô  밡ϹǷ  
    w.writeByte((byte)newUserNo);
    //
    sendFrame(CHAT_LOGOUT, baos.toByteArray());
    baos.close(); baos = null;
    w.close(); w = null;
    //äù濡  ο ˸
    alarm_to_user(CHATUSER_LOGOUT, roomNo, userNo, userId);
  }

  /**
   * äù濡 Ư   ޼ ϱ
   * (äù , äù )
   *
   * (->) major, minor, service(CHATUSER_LOGOUT), byte(ȣ), String(̵)
   * (<-) No
   *
   * @return boolean Լ
   * */
  private final boolean alarm_to_user(byte service, byte roomNo,byte userNo, String userId) throws IOException
  {
    // Ұ쿡 ޼ Ѵ
    //
    ChatRoom room = (ChatRoom)m_rooms.getClient(new Integer(roomNo));
    if (room == null) return false;

    //ϰ 
    ByteArrayOutputStream baos = new ByteArrayOutputStream();
    WriteStream w = new WriteStream(baos);
    w.writeByte(userNo);
    w.writeString(userId);
    byte[] retBody = baos.toByteArray();
    baos.close(); baos = null;
    w.close(); w = null;
    //濡 ִ ο 
    Object[] users = room.getUsrList();
    for (int i=0; i<users.length; i++)
    {
      ChatUser user = (ChatUser)users[i];
      OutputStream os = user.getUnit().getOutputStream();
      sendFrame(service, retBody,os);
    }

    return true;
  }

  /**
   *  äù   
   *
   * (sinario)   Ƿ,
   *            濡 Ѹ̶ ִٸ   Ҽ 
   *
   * (<-) major, minor, service(DESTROY_CHATROOM), byte(ȣ)
   * (->) No
   * */
  private final void destroy_chatroom() throws IOException
  {
    //б
    byte roomNo = m_reader.readByte();
    //
    boolean ret = m_rooms.removeClient(new Integer(roomNo));
  }

  /**
   *  
   * */
  private final void shutdown()
  {
    System.exit(1); //
  }

  /**
   * UnitSender ִ Unitü 
   * @return Unit
   * */
  private final Unit getUnit()
  {
    return m_unit;
  }

  /**
   * д Ʈ  
   * @return ReadStream
   * */
  private final InputStream getInputStream()
  {
    return getUnit().getInputStream();
  }

  /**
   *  Ʈ 
   * @return ReadStream
   * */
  private final OutputStream getOutputStream()
  {
    return getUnit().getOutputStream();
  }

  private boolean isAlive()
  {
    return m_unit.isAlive();
  }

  /**
   * Ʈ  ݰ, 񽺸 Ѵ
   * */
  public void stopService()
  {
    m_unit.clientLogout();
    m_unit.stopService();

    log("stopService()");
  }

  private final void log(String log)
  {
    System.out.println("UnitSender."+log.trim());
  }

  /**
   * 
   *
   * @param service  а (: LOGIN, SEND_MESSAGE  ProtocolInterface ǵȰ)
   * @param body[] 
   * */
  private final void sendFrame(byte service, byte body[]) throws IOException
  {
    m_writer.writeByte(MAJOR_VER);
    m_writer.writeByte(MINOR_VER);
    m_writer.writeByte(service);
    m_writer.write(body, 0, body.length);
    m_writer.flush();
  }

  /**
   * 
   *
   * @param service  а (: LOGIN, SEND_MESSAGE  ProtocolInterface ǵȰ)
   * @param body[] 
   * */
  private final void sendFrame(byte service, byte body[], OutputStream os) throws IOException
  {
    WriteStream w = new WriteStream(os);
    w.writeByte(MAJOR_VER);
    w.writeByte(MINOR_VER);
    w.writeByte(service);
    w.write(body, 0, body.length);
    w.flush();
  }

}